#!/usr/bin/env python

# MintDesktop
#	No Copyright (What for?) Clem <root@linuxmint.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; Version 2
# of the License.

try:
	import os
	import commands
	import sys
	import string
	import pygtk
	pygtk.require("2.0")
except Exception, detail:
	print detail
	pass
try:
	import gtk
	import gtk.glade
except Exception, detail:
	print detail
	sys.exit(1)


class MintDesktop:
	"""MintDesktop - Makes the best out of your Gnome desktop..."""

	def __init__(self):
		# vars
		self.gladefile = '/usr/lib/linuxmint/mintDesktop/mintDesktop_frontend.glade'

		self.appName = "MintDesktop"
		self.appVersion = "1.1"
		
		gtk.glade.bindtextdomain(APPDOMAIN, LANGDIR)
		gtk.glade.textdomain(APPDOMAIN)

		# setup glade widget tree
		self.wTree = gtk.glade.XML(self.gladefile, domain='mintDesktop') 
		
		# create signal dictionary and connect
		dic = { "on_button_ok_clicked" : self.applyChanges,
			"on_main_window_delete_event" : self.exitApp,
			"on_main_window_destroy" : self.exitApp }
		self.wTree.signal_autoconnect(dic)
		
		# set app title
		self.wTree.get_widget("main_window").set_title(self.appName)

		# Get the current configuration
		confComputer = commands.getoutput("gconftool-2 --get /apps/nautilus/desktop/computer_icon_visible")
		if (confComputer == "true"):
			self.wTree.get_widget("checkbox_computer").set_active(1)
		confHome = commands.getoutput("gconftool-2 --get /apps/nautilus/desktop/home_icon_visible")
		if (confHome == "true"):
			self.wTree.get_widget("checkbox_home").set_active(1)
		confNetwork = commands.getoutput("gconftool-2 --get /apps/nautilus/desktop/network_icon_visible")
		if (confNetwork == "true"):
			self.wTree.get_widget("checkbox_network").set_active(1)
		confTrash = commands.getoutput("gconftool-2 --get /apps/nautilus/desktop/trash_icon_visible")
		if (confTrash == "true"):
			self.wTree.get_widget("checkbox_trash").set_active(1)
		confDocuments = commands.getoutput("gconftool-2 --get /apps/nautilus/desktop/documents_icon_visible")
		if (confDocuments == "true"):
			self.wTree.get_widget("checkbox_documents").set_active(1)
		confVolumes = commands.getoutput("gconftool-2 --get /apps/nautilus/desktop/volumes_visible")
		if (confVolumes == "true"):
			self.wTree.get_widget("checkbox_volumes").set_active(1)
		confBrowser = commands.getoutput("gconftool-2 --get /apps/nautilus/preferences/always_use_browser")
		if (confBrowser == "true"):
			self.wTree.get_widget("radio_nautilus_browser").set_active(1)
		else:
			self.wTree.get_widget("radio_nautilus_spatial").set_active(1)
		home = os.environ.get("HOME")
		if (os.path.exists(home + "/.linuxmint/mintDesktop_smb_browsing")):
			self.wTree.get_widget("checkbox_smb_browsing").set_active(1)
		#if (os.path.exists(home + "/.linuxmint/mintDesktop_smb_sharing")):
		#	self.wTree.get_widget("checkbox_smb_sharing").set_active(1)
		#	config_file = open(home + "/.linuxmint/mintDesktop_smb_sharing")
		#	for config_item in config_file.readlines():
		#		if (string.find(config_item, "workgroup") == 0):
		#			array = string.split(config_item)
		#			if (len(array) == 2):
		#				(waste, workgroup) = string.split(config_item)
		#				self.wTree.get_widget("txt_workgroup").set_text(workgroup)
		
	def exitApp(self):
		gtk.main_quit()
		sys.exit(0)

	def applyChanges(self, widget): 
		computer_selected = self.wTree.get_widget("checkbox_computer").get_active()
		if (computer_selected == True):
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/computer_icon_visible true")
		else:
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/computer_icon_visible false")
		
		home_selected = self.wTree.get_widget("checkbox_home").get_active()
		if (home_selected == True):
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/home_icon_visible true")
		else:
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/home_icon_visible false")
		
		network_selected = self.wTree.get_widget("checkbox_network").get_active()
		if (network_selected == True):
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/network_icon_visible true")
		else:
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/network_icon_visible false")
		
		trash_selected = self.wTree.get_widget("checkbox_trash").get_active()
		if (trash_selected == True):
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/trash_icon_visible true")
		else:
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/trash_icon_visible false")
		
		documents_selected = self.wTree.get_widget("checkbox_documents").get_active()
		if (documents_selected == True):
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/documents_icon_visible true")
		else:
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/documents_icon_visible false")
		
		volumes_selected = self.wTree.get_widget("checkbox_volumes").get_active()
		if (volumes_selected == True):
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/volumes_visible true")
		else:
			os.system("gconftool-2 --type bool --set /apps/nautilus/desktop/volumes_visible false")
		
		browser_selected = self.wTree.get_widget("radio_nautilus_browser").get_active()
		if (browser_selected == True):
			os.system("gconftool-2 --type bool --set /apps/nautilus/preferences/always_use_browser true")
		else:
			os.system("gconftool-2 --type bool --set /apps/nautilus/preferences/always_use_browser false")
		
		home = os.environ.get("HOME")
		smb_browsing_selected = self.wTree.get_widget("checkbox_smb_browsing").get_active()
		if (smb_browsing_selected == True):
			os.system("touch " + home + "/.linuxmint/mintDesktop_smb_browsing")
		else:
			os.system("rm " + home + "/.linuxmint/mintDesktop_smb_browsing")
		#smb_sharing_selected = self.wTree.get_widget("checkbox_smb_sharing").get_active()
		#if (smb_sharing_selected == True):
		#	os.system("touch " + home + "/.linuxmint/mintDesktop_smb_sharing")
		#	workgroup = self.wTree.get_widget("txt_workgroup").get_text() 
		#	os.system("echo 'workgroup " + workgroup + "' > " + home + "/.linuxmint/mintDesktop_smb_sharing")
		#else:
		#	os.system("rm " + home + "/.linuxmint/mintDesktop_smb_sharing")
		gtk.main_quit()		
		sys.exit(0)	
			
# ---------- MAIN ----------

if __name__ == "__main__":
	APPDOMAIN='mintDesktop'
	LANGDIR='lang'
	# locale
	gtk.glade.bindtextdomain(APPDOMAIN, LANGDIR)
	gtk.glade.textdomain(APPDOMAIN)
	rec = MintDesktop()
	# run gui
	gtk.main()
