#!/usr/bin/env python

# MintDisk
#	No Copyright (What for?) Clem <root@linuxmint.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; Version 2
# of the License.

try:
	import os
	import commands
	import sys
	import string
	import pygtk
	pygtk.require("2.0")
except Exception, detail:
	print detail
	pass
try:
	import gtk
	import gtk.glade
except Exception, detail:
	print detail
	sys.exit(1)


class MintDisk:
	"""MintDisk - Mount devices automagically..."""

	def __init__(self):
		# vars
		self.gladefile = '/usr/lib/linuxmint/mintDisk/mintDisk_frontend.glade'

		self.appName = "MintDisk"
		self.appVersion = "1.0"
		
		gtk.glade.bindtextdomain(APPDOMAIN, LANGDIR)
		gtk.glade.textdomain(APPDOMAIN)

		# setup glade widget tree
		self.wTree = gtk.glade.XML(self.gladefile, domain='mintDisk') 
		
		# check for user
		if os.getuid() != 0 :
			self.wTree.get_widget("main_window").hide()

		# create signal dictionary and connect
		dic = { "on_button_ok_clicked" : self.applyChanges,
			"on_main_window_delete_event" : self.exitApp,
			"on_main_window_destroy" : self.exitApp }
		self.wTree.signal_autoconnect(dic)
		
		# set app title
		self.wTree.get_widget("main_window").set_title(self.appName)

		# read the mount options
		fat32_type = "b"
		fat32_LBA_type = "c"
		ntfs_type = "7"
		config_file = open("/usr/lib/linuxmint/mintDisk/mount_options")
		for config_item in config_file.readlines():
			(config_type, config_supported, config_mount_type, config_mount_options) = string.split(config_item)
			if (fat32_type == config_type or fat32_LBA_type == config_type):
				self.wTree.get_widget("txt_fat32_mount_type").set_text(config_mount_type)
				self.wTree.get_widget("txt_fat32_mount_options").set_text(config_mount_options)
				if (config_supported == "1"):
					self.wTree.get_widget("checkbox_fat32").set_active(1)
			elif (ntfs_type == config_type):
				self.wTree.get_widget("txt_ntfs_mount_type").set_text(config_mount_type)
				self.wTree.get_widget("txt_ntfs_mount_options").set_text(config_mount_options)
				if (config_supported == "1"):
					self.wTree.get_widget("checkbox_ntfs").set_active(1)
		config_file.close()

		# read the general options
		lnMountPoint = commands.getoutput("cat /usr/lib/linuxmint/mintDisk/options | grep MOUNT_POINT")
		mountPointArray = string.split(lnMountPoint, "=")
		mountPoint = string.strip(mountPointArray[1])
		self.wTree.get_widget("txt_mount_point").set_text(mountPoint)
		
		lnShowLinks = commands.getoutput("cat /usr/lib/linuxmint/mintDisk/options | grep SHOW_LINKS")
		showLinksArray = string.split(lnShowLinks, "=")
		showLinks = string.strip(showLinksArray[1])
		if (showLinks == "1"):
			self.wTree.get_widget("checkbox_show_links").set_active(1)

		lnLinksLocation = commands.getoutput("cat /usr/lib/linuxmint/mintDisk/options | grep LINKS_LOCATION")
		linksLocationArray = string.split(lnLinksLocation, "=")
		linksLocation = string.strip(linksLocationArray[1])
		self.wTree.get_widget("txt_links_location").set_text(linksLocation)
				
	def exitApp(self):
		gtk.main_quit()
		sys.exit(0)

	def applyChanges(self, widget):
		# Write mount options 
		config_file = open("/usr/lib/linuxmint/mintDisk/mount_options", "w")			
		fat32_selected = self.wTree.get_widget("checkbox_fat32").get_active()
		fat32_activated = "0"
		fat32_mount_type = self.wTree.get_widget("txt_fat32_mount_type").get_text()
		fat32_mount_options = self.wTree.get_widget("txt_fat32_mount_options").get_text()
		if (fat32_selected == True):
			fat32_activated = "1"			
		config_file.writelines("b	" + fat32_activated + "	" + fat32_mount_type + "	" + fat32_mount_options + "\n")
		config_file.writelines("c	" + fat32_activated + "	" + fat32_mount_type + "	" + fat32_mount_options + "\n")

		ntfs_selected = self.wTree.get_widget("checkbox_ntfs").get_active()
		ntfs_activated = "0"
		ntfs_mount_type = self.wTree.get_widget("txt_ntfs_mount_type").get_text()
		ntfs_mount_options = self.wTree.get_widget("txt_ntfs_mount_options").get_text()		
		if (ntfs_selected == True):
			ntfs_activated = "1"		
		config_file.writelines("7	" + ntfs_activated + "	" + ntfs_mount_type + "	" + ntfs_mount_options + "\n")

		config_file.close()

		# Write general options
		links_location = self.wTree.get_widget("txt_links_location").get_text()
		mount_point = self.wTree.get_widget("txt_mount_point").get_text()		
		show_links_selected = self.wTree.get_widget("checkbox_show_links").get_active()
		show_links_activated = "0"
		if (show_links_selected == True):
			show_links_activated = "1"		
		config_file = open("/usr/lib/linuxmint/mintDisk/options", "w")			
		config_file.writelines("#-----------------------------------------\n")
		config_file.writelines("# Whether links to the mount point shall be\n") 
		config_file.writelines("# created (1) or not (0)\n")
		config_file.writelines("\n")
		config_file.writelines(" SHOW_LINKS = " + show_links_activated + "\n")
		config_file.writelines("\n")
		config_file.writelines("\n")
		config_file.writelines("#-----------------------------------------\n")
		config_file.writelines("# Where these links should be placed.\n") 
		config_file.writelines("# <<HOME>> represents the user's home folder.\n")
		config_file.writelines("\n")
		config_file.writelines(" LINKS_LOCATION = " + links_location + "\n")
		config_file.writelines("\n")
		config_file.writelines("\n")
		config_file.writelines("#-----------------------------------------\n")
		config_file.writelines("# Where to mount the partitions,\n") 
		config_file.writelines("# <<DEVICE>> represents the device,\n") 
		config_file.writelines("# <<ALIAS>> represents its alias (as defined in the alias file).\n") 
		config_file.writelines("# If you use <<ALIAS>> here, make absolutely sure you have an alias\n")
		config_file.writelines("# defined for each of your partitions!!!\n") 
		config_file.writelines("\n")
		config_file.writelines(" MOUNT_POINT = " + mount_point + "\n")
		config_file.writelines("\n")
		config_file.writelines("\n")

		gtk.main_quit()		
		sys.exit(0)	
			
# ---------- MAIN ----------

if __name__ == "__main__":
	APPDOMAIN='mintDisk'
	LANGDIR='lang'
	# locale
	gtk.glade.bindtextdomain(APPDOMAIN, LANGDIR)
	gtk.glade.textdomain(APPDOMAIN)
	
	# check credentials
	if os.getuid() != 0 :
		## show non-root privledge error
		warnDlg = gtk.Dialog(title="MintDisk", parent=None, flags=0, buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK))
		warnDlg.vbox.set_spacing(10)
		labelSpc = gtk.Label(" ")
		warnDlg.vbox.pack_start(labelSpc)	
		labelSpc.show()
		warnText = ("  <b>You must run with root priviledges.</b>")
		infoText = ("Open a Terminal, change to the directory with mintDisk, \nand type <b>sudo python mintDisk_frontend.py</b>  ")
		label = gtk.Label(warnText)
		lblInfo = gtk.Label(infoText)
		label.set_use_markup(True)
		lblInfo.set_use_markup(True)
		warnDlg.vbox.pack_start(label)
		warnDlg.vbox.pack_start(lblInfo)
		label.show()
		lblInfo.show()
		response = warnDlg.run()
		if response == gtk.RESPONSE_OK :
			warnDlg.destroy()
			#gtk.main_quit()
			sys.exit(0)
	else :
		rec = MintDisk()
		# run gui
		gtk.main()

